-- 新功能开启-model
Lua_FuncOpenModelPanel = class("Lua_FuncOpenModelPanel", Lua_Window)
function Lua_FuncOpenModelPanel:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FuncOpenModelPanel";
	self.skinName = "FuncOpenModelPanel_skin";
	self.showClose = false;
end

function Lua_FuncOpenModelPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_newfunction_1", "gui_newfunction_1", 6, 95);
	self.effect:SetRenderQueue(self.bg, 2, 2, false);

	self.autoTime = Lua_CommonUtil.getCommonConfig("funcopen_model_auto_time", 1);
	
	self.okBtn:addClickFuntion(self, self.hide);

	self:addLuaEvent("CLOSE_FUNC_OPEN_MODEL", self, self.hide);
end

function Lua_FuncOpenModelPanel:hide()
	self:superCall("hide");

	if self.param ~= nil and self.param.floating_model_path ~= nil then
		Lua_WindowUtil.openWin("Lua_ModelFloatingWindow", WinParam.ACTION_OPEN, {id = self.openId, param = self.param});
	elseif Lua_FuncOpenData.isInLimitScene() == false then
		-- 林天山：弹出功能开启提示框时，人物需要停止移动，关闭提示界面后继续执行主线任务（2018.3.15策划需求）
		local truckTaskList = DataCenter.taskData:getListByType(Lua_TaskDefine.TRUCK);
		if truckTaskList:getSize() > 0 then
			DataCenter.hook:doTruckTask();
		end
	end

	-- 林天山 2018.4.24 服务端要求神翼功能特殊处理，模型界面关闭时，发送协议请求穿戴使用
	if self.openId == 10066 then
		local cmd = getProtoMsg("Proto11403814");
		cmd.is_try_out_wing = 1;
		sendMsg(11403814, cmd);
	elseif self.openId ~= nil and self.openId == 10008 then
		-- 特殊需求，侍宠开启时，要同时出战侍宠，并佩戴宠武
		Lua_ProxyManager.getProxy("Lua_ServantProxy"):sFuncOpen();
	elseif self.openId ~= nil and self.openId == 10018 then
		Lua_ProxyManager.getProxy("Lua_ServantWeaponProxy"):sFuncOpen();
	elseif self.openId ~= nil and self.openId == 10010 then
		-- 坐骑开启时坐上坐骑
		Lua_ProxyManager.getProxy("Lua_MountProxy"):sFuncOpen();

		DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.onNewbieGuide);
	elseif self.openId ~= nil and self.openId == 10025 then
		-- 足迹开启
		Lua_ProxyManager.getProxy("Lua_FootprintProxy"):sFuncOpen();
	elseif self.openId ~= nil and self.openId == 10050 then
		-- 法宝开启
		Lua_ProxyManager.getProxy("Lua_MagicWeaponProxy"):sFuncOpen();
	elseif self.openId ~= nil and self.openId == 10061 then
		-- 宠翼开启
		Lua_ProxyManager.getProxy("Lua_ServantWingProxy"):sFuncOpen();
	elseif self.openId ~= nil and self.openId == 10065 then
		-- 宠骑开启
		Lua_ProxyManager.getProxy("Lua_ServantMountProxy"):sFuncOpen();
	elseif self.openId ~= nil and self.openId == 10068 then
		-- 仙器开启
		Lua_ProxyManager.getProxy("Lua_TalismanProxy"):sFuncOpen();
	end
end

function Lua_FuncOpenModelPanel:showWin(val)
	self.openId = val.id;
	self.param = val.param;
	if self.param.guide_id ~= nil then
		DataCenter.guideData.needContinueTruck = true;
	end

	-- print("Lua_FuncOpenModelPanel self.param.id "..tostring(self.openId));
	if self.modelEffect == nil and self.param.open_model_jid ~= nil then
		local myCareer = DataCenter.roleData.career;
		local modelName = self.param.open_model_jid[myCareer];
		self.modelEffect = UICreate.createUIEffect(self.content, "/mounts/" .. tostring(modelName), tostring(modelName), 0, 0)
	end

	local scaleData = self.param.open_model_scale;
	if scaleData ~= nil then
		self.modelEffect:setSacle(scaleData[1], scaleData[2], scaleData[3]);
	end

	local rotData = self.param.open_model_rot;
	if rotData ~= nil then
		self.modelEffect:setRot(rotData[1], rotData[2], rotData[3]);
	end

	local posData = self.param.open_model_pos;
	if posData ~= nil then
		self.modelEffect:setLocation(posData[1], posData[2], posData[3]);
	end
	self.tipsLab.text = self.param.open_desc;
	self.modelEffect:SetRenderQueue(self.bg, 10, 2,false);

	if self.openId == 10050 then
		-- 2018.3.23 策划需求：法宝模型要一直在待机状态
		self.modelEffect:setAction(1);
	elseif self.openId == 10025 then
		-- 2018.3.23 策划需求：足迹模型要循环播放
		-- self.modelEffect:setLoop(true);
		-- 改为交替显影
		Lua_CommonUtil.addTimer("Lua_FuncOpenModelPanel", 2, self, self.showOrHide);
	end

	if self.param.floating_model_path ~= nil then
		Lua_MsgUtil.callFunc("SET_MAIN_MENU", 1);
	end
	self:addTimer("hide", self.autoTime, self, self.hide);
	-- Lua_CommonUtil.delayCall(5,self,self.doFloating,nil);
end

function Lua_FuncOpenModelPanel:showOrHide()
	self.modelEffect:setEnable(false);
	self.modelEffect:setEnable(true);
end

-- function Lua_FuncOpenModelPanel:doFloating(param)
-- 	TweenUtil.getInstance():addTween(self.modelEffect.mainContent,3,0,Vector3(443,-100,0),nil,Vector3(80,80,80));
-- end

function Lua_FuncOpenModelPanel:dispose()
	if self.modelEffect ~= nil then
		self.modelEffect:dispose();
		self.modelEffect = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.showOrHide);

	self:superCall("dispose");
end