-- 新功能开启-图标
Lua_FuncOpenTipsPanel = class("Lua_FuncOpenTipsPanel", Lua_Window);
function Lua_FuncOpenTipsPanel:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FuncOpenTipsPanel";
	self.skinName = "FuncOpenTipsPanel_skin";
	self.blackAlpha = 0.5;
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_FuncOpenTipsPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_newfunction", "gui_newfunction", 4, -2);
	self.effect:SetRenderQueue(self.iconSp, -1, 2);

	self.autoTime = Lua_CommonUtil.getCommonConfig("funcopen_icon_auto_time", 1);

	self:addLuaEvent("CLOSE_FUNC_OPEN_TIPS", self, self.hide);
end

function Lua_FuncOpenTipsPanel:showWin(param)
	self:superCall("showWin", param);

	local rtCfg = getConfig({"topRightIcon"});
	self.rtIconCfg = nil;
	for k,v in pairs(rtCfg) do
		if tostring(k) == tostring(param.icon_id) then
			self.rtIconCfg = v;
			break;
		end
	end

	if self.rtIconCfg ~= nil then
		self.iconName = self.rtIconCfg.floating_icon;
		self.floatTarget = self.rtIconCfg.float_target_path;
		if self.rtIconCfg.floating_icon ~= nil then
			local iconAtlas = self.rtIconCfg.floating_atlas;
			if iconAtlas == nil then
				iconAtlas = "righttop"; -- icon_atlas_1
			end
			self.iconAtlas = iconAtlas;
			self.iconSp:setAltas(iconAtlas, self.rtIconCfg.floating_icon);
		else
			local iconAtlas = self.rtIconCfg.icon_atlas;
			if iconAtlas == nil then
				iconAtlas = "righttop"; -- icon_atlas_1
			end
			self.iconAtlas = iconAtlas;
			self.iconSp:setAltas(iconAtlas, self.rtIconCfg.icon);
		end
	else
		self.iconSp:setAltas(nil, nil);
	end

	if self.rtIconCfg ~= nil and self.rtIconCfg.set_menu_before_floating ~= nil then
		if self.rtIconCfg.pos_type == 2 then
			Lua_MsgUtil.callFunc("SET_MAIN_MENU", self.rtIconCfg.set_menu_before_floating);
		else
			if self.rtIconCfg.set_menu_before_floating == 1 then
				DataCenter.allRtData:setSystemState(true);
				DataCenter.allRtData:setPlayerState(true);
			else
				DataCenter.allRtData:setSystemState(false);
			end
			Lua_MsgUtil.callFunc("TORRIGHT_UPDATE");
		end
	end

	-- if self.rtIconCfg ~= nil and self.rtIconCfg.set_menu_before_floating ~= nil then
	-- 	Lua_MsgUtil.callFunc("SET_MAIN_MENU",self.rtIconCfg.set_menu_before_floating);
	-- end
	self:addTimer("Lua_FuncOpenTipsPanel", self.autoTime, self, self.hide);
end

function Lua_FuncOpenTipsPanel:hide()
	self:superCall("hide");

	if Lua_FuncOpenData.isInLimitScene() == false then
		if self.showData.guide_id == nil then
			local truckTaskList = DataCenter.taskData:getListByType(Lua_TaskDefine.TRUCK);
			if truckTaskList:getSize() > 0 then
				DataCenter.hook:doTruckTask();
			end
		else
			DataCenter.guideData.needContinueTruck = true;
		end
	end

	local rightTopData = DataCenter.allRtData
	-- print("rightTopData.openningRightIconId" .. tostring(rightTopData.openningRightIconId));
	local setMenu = nil;
	if self.rtIconCfg ~= nil and self.rtIconCfg.set_menu_after_floating ~= nil  then
		setMenu = self.rtIconCfg.set_menu_after_floating;
	end

	local doGuide = true;
	if rightTopData.openningRightIconId ~= nil then
		DataCenter.funcOpenData:addFloatIconData({posType = self.rtIconCfg.pos_type, atlas = self.iconAtlas, iconName = self.iconName,
			dispatchEvent = "RIGHT_TOP_FLOATING_COMPLETE", setMenu = setMenu, floatTarget = self.floatTarget,
			targetPosX = rightTopData.curFloatTargetPosX, targetPosY = rightTopData.curFloatTargetPosY});
		
		rightTopData.curFloatTargetPosX = 0;
		rightTopData.curFloatTargetPosY = 0;
		doGuide = false;
	end

	local menuData = DataCenter.menuIconData;
	-- print("menuData.curFloatTargetPosX" .. tostring(menuData.curFloatTargetPosX));
	if self.rtIconCfg.float_target_path ~= nil then
		local sizeStr = LuaUtil.getUIItemSize(self.rtIconCfg.float_target_path);
		local arr = string.split(sizeStr, "|");
		local px = tonumber(arr[3]);
		local py = tonumber(arr[4]);
		DataCenter.funcOpenData:addFloatIconData({posType = self.rtIconCfg.pos_type, atlas = self.iconAtlas, iconName = self.iconName,
			dispatchEvent = "ICON_FLOATING_COMPLETE", setMenu = setMenu, floatTarget = self.floatTarget,
			targetPosX = px, targetPosY = py, showLockEff = self.rtIconCfg.show_lock_lv});
		
		menuData.curFloatTargetPosX = 0;
		menuData.curFloatTargetPosY = 0;
		-- Lua_MsgUtil.callFunc("SET_MAIN_MENU",1);
		doGuide = false;
	end

	DataCenter.funcOpenData:checkShowFloatIconWin();
	if doGuide == true then
		if setMenu ~= nil then
			if self.rtIconCfg.pos_type == 2 then
				Lua_MsgUtil.callFunc("SET_MAIN_MENU", setMenu);
			else
				if setMenu == 1 then
					DataCenter.allRtData:setSystemState(true);
					DataCenter.allRtData:setPlayerState(true);
				else
					DataCenter.allRtData:setSystemState(false);
				end
				Lua_MsgUtil.callFunc("TORRIGHT_UPDATE");
			end
		end
		DataCenter.guideData:doShowGuideWin();
	end
end