Lua_IconFloatingWindow = class("Lua_IconFloatingWindow",Lua_Window)
function Lua_IconFloatingWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_IconFloatingWindow";
	self.isModel = true;
	self.showClose = false;
	self.showBg = false;
	self.isClickClose = false;
	self.blackAlpha = 0.01;
end

function Lua_IconFloatingWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_IconFloatingWindow:showWin(param)
	if param.targetPosX == 0 and param.targetPosY == 0 and param.floatTarget ~= nil then
		local sizeStr = LuaUtil.getUIItemSize(param.floatTarget);
		local arr = string.split(sizeStr,"|");
		param.targetPosX = tonumber(arr[3]);
		param.targetPosY = tonumber(arr[4]);
	end

	self.param = param;
	self.posType = param.posType;
	self.dispatchEvent = param.dispatchEvent;

	if self.iconContainer == nil then
		self.iconContainer = UICreate.createGameObject(self.content);
	end

	if self.iconBg == nil then
		self.iconBg = UICreate.createUIAtlasImage(self.iconContainer,"iconantlas2","activity_icon_bg",0,0,0,0);
		self.iconBg:SetDimensions(74,74);
		self.iconBg:setDepth(9);
	end

	if self.iconSp == nil then
		self.iconSp = UICreate.createUIAtlasImage(self.iconContainer,param.atlas,param.iconName,0,0,0,0);
		self.iconSp:setDepth(10);
	end
	TweenUtil.getInstance():stop(self.iconContainer);
	self.iconSp:setLocation(0, 0, 0);

	local sec = Lua_CommonUtil.getCommonConfig("icon_floating_time", 1);
	local targetPos = Vector3(param.targetPosX, param.targetPosY, 0);
	local dis =  Vector3.Distance(Vector3.zero, targetPos)
	local delayTime = sec / 2;
	if param.speed ~= nil then
		delayTime = dis / param.speed / 4 ;
		sec = dis / param.speed / 2;
	end

	TweenUtil.getInstance():addTween(self.iconContainer, tonumber(sec), 0, targetPos, nil, nil);
	self:addTimer("tweenIconComp",delayTime, self, self.tweenIconComp, nil, 1);

	-- Lua_CommonUtil.delayCall(delayTime, self, self.tweenIconComp, nil);
	-- self:addTimer("tweenIconComp", 4.5, self, self.tweenIconComp, nil, 1);
end

function Lua_IconFloatingWindow:tweenIconComp()
	TweenUtil.getInstance():stop(self.iconContainer);
	Lua_CommonUtil.removeTimer(self, self.tweenIconComp);

	if self.dispatchEvent ~= nil then
		Lua_MsgUtil.callFunc(self.dispatchEvent);
	end

	if self.iconSp ~= nil then
		self.iconSp:dispose();
		self.iconSp = nil;
	end
	self:hide();
end

function Lua_IconFloatingWindow:hide()
	self:superCall("hide");

	if DataCenter.guideData.needGuideId == nil or DataCenter.guideData.needGuideId == 0 then
		if self.param ~= nil and self.param.setMenu ~= nil then
			if self.param.showLockEff ~= nil then
				Lua_CommonUtil.addTimer("delayShowMenu", 1, self, self.delayShowMenu, self.param.setMenu, 1);
			else
				-- self:delayShowMenu(self.param.setMenu);
				local num = Lua_CommonUtil.getCommonConfig("funOpen_flyIconOver_delayTime", 1);
				if num == nil or num < 0 then
					self:delayShowMenu(self.param.setMenu);
				else
					Lua_CommonUtil.addTimer("delayShowMenu", num, self, self.delayShowMenu, self.param.setMenu, 1);
				end
			end
		end
	end
	DataCenter.funcOpenData:checkShowFloatIconWin();
	DataCenter.guideData:doShowGuideWin();
end

function Lua_IconFloatingWindow:delayShowMenu(val)
	if self.posType ~= nil then
		if self.posType == 2 then 
			Lua_MsgUtil.callFunc("SET_MAIN_MENU", val);
		else
			if val == 1 then
				DataCenter.allRtData:setSystemState(true);
				DataCenter.allRtData:setPlayerState(true);
			else
				DataCenter.allRtData:setSystemState(false);
			end
			--Lua_CommonUtil.delayCall(2, self, self.setShowState);
		end
	end
end