Lua_ModelFloatingWindow = class("Lua_ModelFloatingWindow", Lua_Window);
function Lua_ModelFloatingWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ModelFloatingWindow";
	self.blackAlpha = 0.01;
	self.showClose = false;
end

function Lua_ModelFloatingWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ModelFloatingWindow:showWin(param)
	self.param = param.param;
	
	if self.iconContainer == nil then
		self.iconContainer = UICreate.createGameObject(self.content);
	end

	if self.iconBg == nil then
		self.iconBg = UICreate.createUIAtlasImage(self.iconContainer, "iconantlas2", "activity_icon_bg", 0, 0, 0, 0);
		self.iconBg:SetDimensions(74, 74);
		self.iconBg:setDepth(9);
	end

	if self.iconSp == nil then
		local rtCfg = getConfig({"topRightIcon"});
		self.curIconCfg = nil;
		local iconAtlas;
		local iconName;
		for k,v in pairs(rtCfg) do
			if tostring(k) == tostring(self.param.icon_id) then
				self.curIconCfg  = v;

				iconName = v.floating_icon;
				iconAtlas = v.floating_atlas == nil and v.icon_atlas or v.floating_atlas;
				iconAtlas = iconAtlas == nil and "righttop" or iconAtlas;
				break;
			end
		end
		self.iconSp = UICreate.createUIAtlasImage(self.iconContainer, iconAtlas, iconName, 0, 0, 0, 0);
		self.iconSp:setDepth(10);
	end
	TweenUtil.getInstance():stop(self.iconContainer);
	self.iconSp:setLocation(0, 0, 0);
	
	local sec = Lua_CommonUtil.getCommonConfig("icon_floating_time", 1);
	Lua_CommonUtil.delayCall(sec, self, self.hide, nil);

	local sizeStr = LuaUtil.getUIItemSize(self.param.floating_model_path);
	local arr = string.split(sizeStr,"|");
	local px = tonumber(arr[3]);
	local py = tonumber(arr[4]);
	local targetPos = Vector3(px ,py, 0);
	-- TweenUtil.getInstance():stop(self.modelEffect.mainContent);
	TweenUtil.getInstance():addTween(self.iconContainer, sec, 1, targetPos , nil, nil);
end

function Lua_ModelFloatingWindow:hide()
	self:superCall("hide");

	local truckTaskList = DataCenter.taskData:getListByType(Lua_TaskDefine.TRUCK);
	if truckTaskList:getSize() > 0 then
		DataCenter.hook:doTruckTask();
	end

	-- print(self.curIconCfg.pos_type, self.curIconCfg.set_menu_after_floating);
	if self.curIconCfg ~= nil and self.curIconCfg.set_menu_after_floating ~= nil then
		-- Lua_MsgUtil.callFunc("SET_MAIN_MENU", self.curIconCfg.set_menu_after_floating);
		if self.curIconCfg.pos_type == 2 then -- 右侧主功能图标栏
			Lua_MsgUtil.callFunc("SET_MAIN_MENU", self.curIconCfg.set_menu_after_floating);
		else
			if self.curIconCfg.set_menu_after_floating == 1 then
		        DataCenter.allRtData:setSystemState(true);
		        DataCenter.allRtData:setPlayerState(true);
		    else
		        DataCenter.allRtData:setSystemState(false);
		    end
		    Lua_MsgUtil.callFunc("TORRIGHT_UPDATE");
		end
	end
	Lua_MsgUtil.callFunc("ICON_FLOATING_COMPLETE");
end